package hu.bme.mit.ui.contentassist.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.DFA;
import hu.bme.mit.services.SocialNetworkLanguageGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalSocialNetworkLanguageParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'male'", "'female'", "'friend'", "'colleague'", "'network'", "'{'", "'}'", "'person'", "'memberships'", "','", "'community'", "'acquaintance'", "'is'", "'of'"
    };
    public static final int RULE_ID=4;
    public static final int T__24=24;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=6;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalSocialNetworkLanguageParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalSocialNetworkLanguageParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalSocialNetworkLanguageParser.tokenNames; }
    public String getGrammarFileName() { return "../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g"; }


     
     	private SocialNetworkLanguageGrammarAccess grammarAccess;
     	
        public void setGrammarAccess(SocialNetworkLanguageGrammarAccess grammarAccess) {
        	this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected Grammar getGrammar() {
        	return grammarAccess.getGrammar();
        }
        
        @Override
        protected String getValueForTokenName(String tokenName) {
        	return tokenName;
        }




    // $ANTLR start "entryRuleSocialNetwork"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:60:1: entryRuleSocialNetwork : ruleSocialNetwork EOF ;
    public final void entryRuleSocialNetwork() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:61:1: ( ruleSocialNetwork EOF )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:62:1: ruleSocialNetwork EOF
            {
             before(grammarAccess.getSocialNetworkRule()); 
            pushFollow(FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork61);
            ruleSocialNetwork();

            state._fsp--;

             after(grammarAccess.getSocialNetworkRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialNetwork68); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleSocialNetwork"


    // $ANTLR start "ruleSocialNetwork"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:69:1: ruleSocialNetwork : ( ( rule__SocialNetwork__Group__0 ) ) ;
    public final void ruleSocialNetwork() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:73:2: ( ( ( rule__SocialNetwork__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:74:1: ( ( rule__SocialNetwork__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:74:1: ( ( rule__SocialNetwork__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:75:1: ( rule__SocialNetwork__Group__0 )
            {
             before(grammarAccess.getSocialNetworkAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:76:1: ( rule__SocialNetwork__Group__0 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:76:2: rule__SocialNetwork__Group__0
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__0_in_ruleSocialNetwork94);
            rule__SocialNetwork__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getSocialNetworkAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSocialNetwork"


    // $ANTLR start "entryRuleEntity"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:88:1: entryRuleEntity : ruleEntity EOF ;
    public final void entryRuleEntity() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:89:1: ( ruleEntity EOF )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:90:1: ruleEntity EOF
            {
             before(grammarAccess.getEntityRule()); 
            pushFollow(FOLLOW_ruleEntity_in_entryRuleEntity121);
            ruleEntity();

            state._fsp--;

             after(grammarAccess.getEntityRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleEntity128); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleEntity"


    // $ANTLR start "ruleEntity"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:97:1: ruleEntity : ( ( rule__Entity__Alternatives ) ) ;
    public final void ruleEntity() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:101:2: ( ( ( rule__Entity__Alternatives ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:102:1: ( ( rule__Entity__Alternatives ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:102:1: ( ( rule__Entity__Alternatives ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:103:1: ( rule__Entity__Alternatives )
            {
             before(grammarAccess.getEntityAccess().getAlternatives()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:104:1: ( rule__Entity__Alternatives )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:104:2: rule__Entity__Alternatives
            {
            pushFollow(FOLLOW_rule__Entity__Alternatives_in_ruleEntity154);
            rule__Entity__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getEntityAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleEntity"


    // $ANTLR start "entryRulePerson"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:116:1: entryRulePerson : rulePerson EOF ;
    public final void entryRulePerson() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:117:1: ( rulePerson EOF )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:118:1: rulePerson EOF
            {
             before(grammarAccess.getPersonRule()); 
            pushFollow(FOLLOW_rulePerson_in_entryRulePerson181);
            rulePerson();

            state._fsp--;

             after(grammarAccess.getPersonRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRulePerson188); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePerson"


    // $ANTLR start "rulePerson"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:125:1: rulePerson : ( ( rule__Person__Group__0 ) ) ;
    public final void rulePerson() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:129:2: ( ( ( rule__Person__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:130:1: ( ( rule__Person__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:130:1: ( ( rule__Person__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:131:1: ( rule__Person__Group__0 )
            {
             before(grammarAccess.getPersonAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:132:1: ( rule__Person__Group__0 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:132:2: rule__Person__Group__0
            {
            pushFollow(FOLLOW_rule__Person__Group__0_in_rulePerson214);
            rule__Person__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePerson"


    // $ANTLR start "entryRuleCommunity"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:144:1: entryRuleCommunity : ruleCommunity EOF ;
    public final void entryRuleCommunity() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:145:1: ( ruleCommunity EOF )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:146:1: ruleCommunity EOF
            {
             before(grammarAccess.getCommunityRule()); 
            pushFollow(FOLLOW_ruleCommunity_in_entryRuleCommunity241);
            ruleCommunity();

            state._fsp--;

             after(grammarAccess.getCommunityRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCommunity248); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleCommunity"


    // $ANTLR start "ruleCommunity"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:153:1: ruleCommunity : ( ( rule__Community__Group__0 ) ) ;
    public final void ruleCommunity() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:157:2: ( ( ( rule__Community__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:158:1: ( ( rule__Community__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:158:1: ( ( rule__Community__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:159:1: ( rule__Community__Group__0 )
            {
             before(grammarAccess.getCommunityAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:160:1: ( rule__Community__Group__0 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:160:2: rule__Community__Group__0
            {
            pushFollow(FOLLOW_rule__Community__Group__0_in_ruleCommunity274);
            rule__Community__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getCommunityAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleCommunity"


    // $ANTLR start "entryRuleAcquaintance"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:172:1: entryRuleAcquaintance : ruleAcquaintance EOF ;
    public final void entryRuleAcquaintance() throws RecognitionException {
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:173:1: ( ruleAcquaintance EOF )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:174:1: ruleAcquaintance EOF
            {
             before(grammarAccess.getAcquaintanceRule()); 
            pushFollow(FOLLOW_ruleAcquaintance_in_entryRuleAcquaintance301);
            ruleAcquaintance();

            state._fsp--;

             after(grammarAccess.getAcquaintanceRule()); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleAcquaintance308); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAcquaintance"


    // $ANTLR start "ruleAcquaintance"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:181:1: ruleAcquaintance : ( ( rule__Acquaintance__Group__0 ) ) ;
    public final void ruleAcquaintance() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:185:2: ( ( ( rule__Acquaintance__Group__0 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:186:1: ( ( rule__Acquaintance__Group__0 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:186:1: ( ( rule__Acquaintance__Group__0 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:187:1: ( rule__Acquaintance__Group__0 )
            {
             before(grammarAccess.getAcquaintanceAccess().getGroup()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:188:1: ( rule__Acquaintance__Group__0 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:188:2: rule__Acquaintance__Group__0
            {
            pushFollow(FOLLOW_rule__Acquaintance__Group__0_in_ruleAcquaintance334);
            rule__Acquaintance__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintanceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAcquaintance"


    // $ANTLR start "ruleSex"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:201:1: ruleSex : ( ( rule__Sex__Alternatives ) ) ;
    public final void ruleSex() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:205:1: ( ( ( rule__Sex__Alternatives ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:206:1: ( ( rule__Sex__Alternatives ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:206:1: ( ( rule__Sex__Alternatives ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:207:1: ( rule__Sex__Alternatives )
            {
             before(grammarAccess.getSexAccess().getAlternatives()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:208:1: ( rule__Sex__Alternatives )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:208:2: rule__Sex__Alternatives
            {
            pushFollow(FOLLOW_rule__Sex__Alternatives_in_ruleSex371);
            rule__Sex__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getSexAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSex"


    // $ANTLR start "ruleAcquaintanceType"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:220:1: ruleAcquaintanceType : ( ( rule__AcquaintanceType__Alternatives ) ) ;
    public final void ruleAcquaintanceType() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:224:1: ( ( ( rule__AcquaintanceType__Alternatives ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:225:1: ( ( rule__AcquaintanceType__Alternatives ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:225:1: ( ( rule__AcquaintanceType__Alternatives ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:226:1: ( rule__AcquaintanceType__Alternatives )
            {
             before(grammarAccess.getAcquaintanceTypeAccess().getAlternatives()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:227:1: ( rule__AcquaintanceType__Alternatives )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:227:2: rule__AcquaintanceType__Alternatives
            {
            pushFollow(FOLLOW_rule__AcquaintanceType__Alternatives_in_ruleAcquaintanceType407);
            rule__AcquaintanceType__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintanceTypeAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAcquaintanceType"


    // $ANTLR start "rule__SocialNetwork__Alternatives_2"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:238:1: rule__SocialNetwork__Alternatives_2 : ( ( ( rule__SocialNetwork__EntitiesAssignment_2_0 ) ) | ( ( rule__SocialNetwork__AcquaintancesAssignment_2_1 ) ) );
    public final void rule__SocialNetwork__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:242:1: ( ( ( rule__SocialNetwork__EntitiesAssignment_2_0 ) ) | ( ( rule__SocialNetwork__AcquaintancesAssignment_2_1 ) ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==18||LA1_0==21) ) {
                alt1=1;
            }
            else if ( (LA1_0==22) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:243:1: ( ( rule__SocialNetwork__EntitiesAssignment_2_0 ) )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:243:1: ( ( rule__SocialNetwork__EntitiesAssignment_2_0 ) )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:244:1: ( rule__SocialNetwork__EntitiesAssignment_2_0 )
                    {
                     before(grammarAccess.getSocialNetworkAccess().getEntitiesAssignment_2_0()); 
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:245:1: ( rule__SocialNetwork__EntitiesAssignment_2_0 )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:245:2: rule__SocialNetwork__EntitiesAssignment_2_0
                    {
                    pushFollow(FOLLOW_rule__SocialNetwork__EntitiesAssignment_2_0_in_rule__SocialNetwork__Alternatives_2442);
                    rule__SocialNetwork__EntitiesAssignment_2_0();

                    state._fsp--;


                    }

                     after(grammarAccess.getSocialNetworkAccess().getEntitiesAssignment_2_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:249:6: ( ( rule__SocialNetwork__AcquaintancesAssignment_2_1 ) )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:249:6: ( ( rule__SocialNetwork__AcquaintancesAssignment_2_1 ) )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:250:1: ( rule__SocialNetwork__AcquaintancesAssignment_2_1 )
                    {
                     before(grammarAccess.getSocialNetworkAccess().getAcquaintancesAssignment_2_1()); 
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:251:1: ( rule__SocialNetwork__AcquaintancesAssignment_2_1 )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:251:2: rule__SocialNetwork__AcquaintancesAssignment_2_1
                    {
                    pushFollow(FOLLOW_rule__SocialNetwork__AcquaintancesAssignment_2_1_in_rule__SocialNetwork__Alternatives_2460);
                    rule__SocialNetwork__AcquaintancesAssignment_2_1();

                    state._fsp--;


                    }

                     after(grammarAccess.getSocialNetworkAccess().getAcquaintancesAssignment_2_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Alternatives_2"


    // $ANTLR start "rule__Entity__Alternatives"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:260:1: rule__Entity__Alternatives : ( ( rulePerson ) | ( ruleCommunity ) );
    public final void rule__Entity__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:264:1: ( ( rulePerson ) | ( ruleCommunity ) )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==18) ) {
                alt2=1;
            }
            else if ( (LA2_0==21) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:265:1: ( rulePerson )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:265:1: ( rulePerson )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:266:1: rulePerson
                    {
                     before(grammarAccess.getEntityAccess().getPersonParserRuleCall_0()); 
                    pushFollow(FOLLOW_rulePerson_in_rule__Entity__Alternatives493);
                    rulePerson();

                    state._fsp--;

                     after(grammarAccess.getEntityAccess().getPersonParserRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:271:6: ( ruleCommunity )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:271:6: ( ruleCommunity )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:272:1: ruleCommunity
                    {
                     before(grammarAccess.getEntityAccess().getCommunityParserRuleCall_1()); 
                    pushFollow(FOLLOW_ruleCommunity_in_rule__Entity__Alternatives510);
                    ruleCommunity();

                    state._fsp--;

                     after(grammarAccess.getEntityAccess().getCommunityParserRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Alternatives"


    // $ANTLR start "rule__Sex__Alternatives"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:282:1: rule__Sex__Alternatives : ( ( ( 'male' ) ) | ( ( 'female' ) ) );
    public final void rule__Sex__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:286:1: ( ( ( 'male' ) ) | ( ( 'female' ) ) )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==11) ) {
                alt3=1;
            }
            else if ( (LA3_0==12) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:287:1: ( ( 'male' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:287:1: ( ( 'male' ) )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:288:1: ( 'male' )
                    {
                     before(grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0()); 
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:289:1: ( 'male' )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:289:3: 'male'
                    {
                    match(input,11,FOLLOW_11_in_rule__Sex__Alternatives543); 

                    }

                     after(grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:294:6: ( ( 'female' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:294:6: ( ( 'female' ) )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:295:1: ( 'female' )
                    {
                     before(grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1()); 
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:296:1: ( 'female' )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:296:3: 'female'
                    {
                    match(input,12,FOLLOW_12_in_rule__Sex__Alternatives564); 

                    }

                     after(grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Sex__Alternatives"


    // $ANTLR start "rule__AcquaintanceType__Alternatives"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:306:1: rule__AcquaintanceType__Alternatives : ( ( ( 'friend' ) ) | ( ( 'colleague' ) ) );
    public final void rule__AcquaintanceType__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:310:1: ( ( ( 'friend' ) ) | ( ( 'colleague' ) ) )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==13) ) {
                alt4=1;
            }
            else if ( (LA4_0==14) ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:311:1: ( ( 'friend' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:311:1: ( ( 'friend' ) )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:312:1: ( 'friend' )
                    {
                     before(grammarAccess.getAcquaintanceTypeAccess().getFriendEnumLiteralDeclaration_0()); 
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:313:1: ( 'friend' )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:313:3: 'friend'
                    {
                    match(input,13,FOLLOW_13_in_rule__AcquaintanceType__Alternatives600); 

                    }

                     after(grammarAccess.getAcquaintanceTypeAccess().getFriendEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:318:6: ( ( 'colleague' ) )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:318:6: ( ( 'colleague' ) )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:319:1: ( 'colleague' )
                    {
                     before(grammarAccess.getAcquaintanceTypeAccess().getCollegueEnumLiteralDeclaration_1()); 
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:320:1: ( 'colleague' )
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:320:3: 'colleague'
                    {
                    match(input,14,FOLLOW_14_in_rule__AcquaintanceType__Alternatives621); 

                    }

                     after(grammarAccess.getAcquaintanceTypeAccess().getCollegueEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AcquaintanceType__Alternatives"


    // $ANTLR start "rule__SocialNetwork__Group__0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:332:1: rule__SocialNetwork__Group__0 : rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1 ;
    public final void rule__SocialNetwork__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:336:1: ( rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:337:2: rule__SocialNetwork__Group__0__Impl rule__SocialNetwork__Group__1
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__0__Impl_in_rule__SocialNetwork__Group__0654);
            rule__SocialNetwork__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__1_in_rule__SocialNetwork__Group__0657);
            rule__SocialNetwork__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__0"


    // $ANTLR start "rule__SocialNetwork__Group__0__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:344:1: rule__SocialNetwork__Group__0__Impl : ( 'network' ) ;
    public final void rule__SocialNetwork__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:348:1: ( ( 'network' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:349:1: ( 'network' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:349:1: ( 'network' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:350:1: 'network'
            {
             before(grammarAccess.getSocialNetworkAccess().getNetworkKeyword_0()); 
            match(input,15,FOLLOW_15_in_rule__SocialNetwork__Group__0__Impl685); 
             after(grammarAccess.getSocialNetworkAccess().getNetworkKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__0__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:363:1: rule__SocialNetwork__Group__1 : rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2 ;
    public final void rule__SocialNetwork__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:367:1: ( rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:368:2: rule__SocialNetwork__Group__1__Impl rule__SocialNetwork__Group__2
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__1__Impl_in_rule__SocialNetwork__Group__1716);
            rule__SocialNetwork__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__2_in_rule__SocialNetwork__Group__1719);
            rule__SocialNetwork__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__1"


    // $ANTLR start "rule__SocialNetwork__Group__1__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:375:1: rule__SocialNetwork__Group__1__Impl : ( '{' ) ;
    public final void rule__SocialNetwork__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:379:1: ( ( '{' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:380:1: ( '{' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:380:1: ( '{' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:381:1: '{'
            {
             before(grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_1()); 
            match(input,16,FOLLOW_16_in_rule__SocialNetwork__Group__1__Impl747); 
             after(grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__1__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__2"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:394:1: rule__SocialNetwork__Group__2 : rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3 ;
    public final void rule__SocialNetwork__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:398:1: ( rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:399:2: rule__SocialNetwork__Group__2__Impl rule__SocialNetwork__Group__3
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__2__Impl_in_rule__SocialNetwork__Group__2778);
            rule__SocialNetwork__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__SocialNetwork__Group__3_in_rule__SocialNetwork__Group__2781);
            rule__SocialNetwork__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__2"


    // $ANTLR start "rule__SocialNetwork__Group__2__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:406:1: rule__SocialNetwork__Group__2__Impl : ( ( ( rule__SocialNetwork__Alternatives_2 ) ) ( ( rule__SocialNetwork__Alternatives_2 )* ) ) ;
    public final void rule__SocialNetwork__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:410:1: ( ( ( ( rule__SocialNetwork__Alternatives_2 ) ) ( ( rule__SocialNetwork__Alternatives_2 )* ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:411:1: ( ( ( rule__SocialNetwork__Alternatives_2 ) ) ( ( rule__SocialNetwork__Alternatives_2 )* ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:411:1: ( ( ( rule__SocialNetwork__Alternatives_2 ) ) ( ( rule__SocialNetwork__Alternatives_2 )* ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:412:1: ( ( rule__SocialNetwork__Alternatives_2 ) ) ( ( rule__SocialNetwork__Alternatives_2 )* )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:412:1: ( ( rule__SocialNetwork__Alternatives_2 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:413:1: ( rule__SocialNetwork__Alternatives_2 )
            {
             before(grammarAccess.getSocialNetworkAccess().getAlternatives_2()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:414:1: ( rule__SocialNetwork__Alternatives_2 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:414:2: rule__SocialNetwork__Alternatives_2
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Alternatives_2_in_rule__SocialNetwork__Group__2__Impl810);
            rule__SocialNetwork__Alternatives_2();

            state._fsp--;


            }

             after(grammarAccess.getSocialNetworkAccess().getAlternatives_2()); 

            }

            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:417:1: ( ( rule__SocialNetwork__Alternatives_2 )* )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:418:1: ( rule__SocialNetwork__Alternatives_2 )*
            {
             before(grammarAccess.getSocialNetworkAccess().getAlternatives_2()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:419:1: ( rule__SocialNetwork__Alternatives_2 )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==18||(LA5_0>=21 && LA5_0<=22)) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:419:2: rule__SocialNetwork__Alternatives_2
            	    {
            	    pushFollow(FOLLOW_rule__SocialNetwork__Alternatives_2_in_rule__SocialNetwork__Group__2__Impl822);
            	    rule__SocialNetwork__Alternatives_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

             after(grammarAccess.getSocialNetworkAccess().getAlternatives_2()); 

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__2__Impl"


    // $ANTLR start "rule__SocialNetwork__Group__3"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:430:1: rule__SocialNetwork__Group__3 : rule__SocialNetwork__Group__3__Impl ;
    public final void rule__SocialNetwork__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:434:1: ( rule__SocialNetwork__Group__3__Impl )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:435:2: rule__SocialNetwork__Group__3__Impl
            {
            pushFollow(FOLLOW_rule__SocialNetwork__Group__3__Impl_in_rule__SocialNetwork__Group__3855);
            rule__SocialNetwork__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__3"


    // $ANTLR start "rule__SocialNetwork__Group__3__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:441:1: rule__SocialNetwork__Group__3__Impl : ( '}' ) ;
    public final void rule__SocialNetwork__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:445:1: ( ( '}' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:446:1: ( '}' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:446:1: ( '}' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:447:1: '}'
            {
             before(grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_3()); 
            match(input,17,FOLLOW_17_in_rule__SocialNetwork__Group__3__Impl883); 
             after(grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__Group__3__Impl"


    // $ANTLR start "rule__Person__Group__0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:468:1: rule__Person__Group__0 : rule__Person__Group__0__Impl rule__Person__Group__1 ;
    public final void rule__Person__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:472:1: ( rule__Person__Group__0__Impl rule__Person__Group__1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:473:2: rule__Person__Group__0__Impl rule__Person__Group__1
            {
            pushFollow(FOLLOW_rule__Person__Group__0__Impl_in_rule__Person__Group__0922);
            rule__Person__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__1_in_rule__Person__Group__0925);
            rule__Person__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__0"


    // $ANTLR start "rule__Person__Group__0__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:480:1: rule__Person__Group__0__Impl : ( 'person' ) ;
    public final void rule__Person__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:484:1: ( ( 'person' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:485:1: ( 'person' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:485:1: ( 'person' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:486:1: 'person'
            {
             before(grammarAccess.getPersonAccess().getPersonKeyword_0()); 
            match(input,18,FOLLOW_18_in_rule__Person__Group__0__Impl953); 
             after(grammarAccess.getPersonAccess().getPersonKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__0__Impl"


    // $ANTLR start "rule__Person__Group__1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:499:1: rule__Person__Group__1 : rule__Person__Group__1__Impl rule__Person__Group__2 ;
    public final void rule__Person__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:503:1: ( rule__Person__Group__1__Impl rule__Person__Group__2 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:504:2: rule__Person__Group__1__Impl rule__Person__Group__2
            {
            pushFollow(FOLLOW_rule__Person__Group__1__Impl_in_rule__Person__Group__1984);
            rule__Person__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__2_in_rule__Person__Group__1987);
            rule__Person__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__1"


    // $ANTLR start "rule__Person__Group__1__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:511:1: rule__Person__Group__1__Impl : ( ( rule__Person__NameAssignment_1 ) ) ;
    public final void rule__Person__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:515:1: ( ( ( rule__Person__NameAssignment_1 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:516:1: ( ( rule__Person__NameAssignment_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:516:1: ( ( rule__Person__NameAssignment_1 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:517:1: ( rule__Person__NameAssignment_1 )
            {
             before(grammarAccess.getPersonAccess().getNameAssignment_1()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:518:1: ( rule__Person__NameAssignment_1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:518:2: rule__Person__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Person__NameAssignment_1_in_rule__Person__Group__1__Impl1014);
            rule__Person__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__1__Impl"


    // $ANTLR start "rule__Person__Group__2"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:528:1: rule__Person__Group__2 : rule__Person__Group__2__Impl rule__Person__Group__3 ;
    public final void rule__Person__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:532:1: ( rule__Person__Group__2__Impl rule__Person__Group__3 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:533:2: rule__Person__Group__2__Impl rule__Person__Group__3
            {
            pushFollow(FOLLOW_rule__Person__Group__2__Impl_in_rule__Person__Group__21044);
            rule__Person__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__3_in_rule__Person__Group__21047);
            rule__Person__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__2"


    // $ANTLR start "rule__Person__Group__2__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:540:1: rule__Person__Group__2__Impl : ( '{' ) ;
    public final void rule__Person__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:544:1: ( ( '{' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:545:1: ( '{' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:545:1: ( '{' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:546:1: '{'
            {
             before(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,16,FOLLOW_16_in_rule__Person__Group__2__Impl1075); 
             after(grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__2__Impl"


    // $ANTLR start "rule__Person__Group__3"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:559:1: rule__Person__Group__3 : rule__Person__Group__3__Impl rule__Person__Group__4 ;
    public final void rule__Person__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:563:1: ( rule__Person__Group__3__Impl rule__Person__Group__4 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:564:2: rule__Person__Group__3__Impl rule__Person__Group__4
            {
            pushFollow(FOLLOW_rule__Person__Group__3__Impl_in_rule__Person__Group__31106);
            rule__Person__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__4_in_rule__Person__Group__31109);
            rule__Person__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__3"


    // $ANTLR start "rule__Person__Group__3__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:571:1: rule__Person__Group__3__Impl : ( ( rule__Person__SexAssignment_3 ) ) ;
    public final void rule__Person__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:575:1: ( ( ( rule__Person__SexAssignment_3 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:576:1: ( ( rule__Person__SexAssignment_3 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:576:1: ( ( rule__Person__SexAssignment_3 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:577:1: ( rule__Person__SexAssignment_3 )
            {
             before(grammarAccess.getPersonAccess().getSexAssignment_3()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:578:1: ( rule__Person__SexAssignment_3 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:578:2: rule__Person__SexAssignment_3
            {
            pushFollow(FOLLOW_rule__Person__SexAssignment_3_in_rule__Person__Group__3__Impl1136);
            rule__Person__SexAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getSexAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__3__Impl"


    // $ANTLR start "rule__Person__Group__4"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:588:1: rule__Person__Group__4 : rule__Person__Group__4__Impl rule__Person__Group__5 ;
    public final void rule__Person__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:592:1: ( rule__Person__Group__4__Impl rule__Person__Group__5 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:593:2: rule__Person__Group__4__Impl rule__Person__Group__5
            {
            pushFollow(FOLLOW_rule__Person__Group__4__Impl_in_rule__Person__Group__41166);
            rule__Person__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group__5_in_rule__Person__Group__41169);
            rule__Person__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__4"


    // $ANTLR start "rule__Person__Group__4__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:600:1: rule__Person__Group__4__Impl : ( ( rule__Person__Group_4__0 )? ) ;
    public final void rule__Person__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:604:1: ( ( ( rule__Person__Group_4__0 )? ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:605:1: ( ( rule__Person__Group_4__0 )? )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:605:1: ( ( rule__Person__Group_4__0 )? )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:606:1: ( rule__Person__Group_4__0 )?
            {
             before(grammarAccess.getPersonAccess().getGroup_4()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:607:1: ( rule__Person__Group_4__0 )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==19) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:607:2: rule__Person__Group_4__0
                    {
                    pushFollow(FOLLOW_rule__Person__Group_4__0_in_rule__Person__Group__4__Impl1196);
                    rule__Person__Group_4__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPersonAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__4__Impl"


    // $ANTLR start "rule__Person__Group__5"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:617:1: rule__Person__Group__5 : rule__Person__Group__5__Impl ;
    public final void rule__Person__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:621:1: ( rule__Person__Group__5__Impl )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:622:2: rule__Person__Group__5__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group__5__Impl_in_rule__Person__Group__51227);
            rule__Person__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__5"


    // $ANTLR start "rule__Person__Group__5__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:628:1: rule__Person__Group__5__Impl : ( '}' ) ;
    public final void rule__Person__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:632:1: ( ( '}' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:633:1: ( '}' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:633:1: ( '}' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:634:1: '}'
            {
             before(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_5()); 
            match(input,17,FOLLOW_17_in_rule__Person__Group__5__Impl1255); 
             after(grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group__5__Impl"


    // $ANTLR start "rule__Person__Group_4__0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:659:1: rule__Person__Group_4__0 : rule__Person__Group_4__0__Impl rule__Person__Group_4__1 ;
    public final void rule__Person__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:663:1: ( rule__Person__Group_4__0__Impl rule__Person__Group_4__1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:664:2: rule__Person__Group_4__0__Impl rule__Person__Group_4__1
            {
            pushFollow(FOLLOW_rule__Person__Group_4__0__Impl_in_rule__Person__Group_4__01298);
            rule__Person__Group_4__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group_4__1_in_rule__Person__Group_4__01301);
            rule__Person__Group_4__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4__0"


    // $ANTLR start "rule__Person__Group_4__0__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:671:1: rule__Person__Group_4__0__Impl : ( 'memberships' ) ;
    public final void rule__Person__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:675:1: ( ( 'memberships' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:676:1: ( 'memberships' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:676:1: ( 'memberships' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:677:1: 'memberships'
            {
             before(grammarAccess.getPersonAccess().getMembershipsKeyword_4_0()); 
            match(input,19,FOLLOW_19_in_rule__Person__Group_4__0__Impl1329); 
             after(grammarAccess.getPersonAccess().getMembershipsKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4__0__Impl"


    // $ANTLR start "rule__Person__Group_4__1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:690:1: rule__Person__Group_4__1 : rule__Person__Group_4__1__Impl rule__Person__Group_4__2 ;
    public final void rule__Person__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:694:1: ( rule__Person__Group_4__1__Impl rule__Person__Group_4__2 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:695:2: rule__Person__Group_4__1__Impl rule__Person__Group_4__2
            {
            pushFollow(FOLLOW_rule__Person__Group_4__1__Impl_in_rule__Person__Group_4__11360);
            rule__Person__Group_4__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group_4__2_in_rule__Person__Group_4__11363);
            rule__Person__Group_4__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4__1"


    // $ANTLR start "rule__Person__Group_4__1__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:702:1: rule__Person__Group_4__1__Impl : ( ( rule__Person__MembershipsAssignment_4_1 ) ) ;
    public final void rule__Person__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:706:1: ( ( ( rule__Person__MembershipsAssignment_4_1 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:707:1: ( ( rule__Person__MembershipsAssignment_4_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:707:1: ( ( rule__Person__MembershipsAssignment_4_1 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:708:1: ( rule__Person__MembershipsAssignment_4_1 )
            {
             before(grammarAccess.getPersonAccess().getMembershipsAssignment_4_1()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:709:1: ( rule__Person__MembershipsAssignment_4_1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:709:2: rule__Person__MembershipsAssignment_4_1
            {
            pushFollow(FOLLOW_rule__Person__MembershipsAssignment_4_1_in_rule__Person__Group_4__1__Impl1390);
            rule__Person__MembershipsAssignment_4_1();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getMembershipsAssignment_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4__1__Impl"


    // $ANTLR start "rule__Person__Group_4__2"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:719:1: rule__Person__Group_4__2 : rule__Person__Group_4__2__Impl ;
    public final void rule__Person__Group_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:723:1: ( rule__Person__Group_4__2__Impl )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:724:2: rule__Person__Group_4__2__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group_4__2__Impl_in_rule__Person__Group_4__21420);
            rule__Person__Group_4__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4__2"


    // $ANTLR start "rule__Person__Group_4__2__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:730:1: rule__Person__Group_4__2__Impl : ( ( rule__Person__Group_4_2__0 )* ) ;
    public final void rule__Person__Group_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:734:1: ( ( ( rule__Person__Group_4_2__0 )* ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:735:1: ( ( rule__Person__Group_4_2__0 )* )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:735:1: ( ( rule__Person__Group_4_2__0 )* )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:736:1: ( rule__Person__Group_4_2__0 )*
            {
             before(grammarAccess.getPersonAccess().getGroup_4_2()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:737:1: ( rule__Person__Group_4_2__0 )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==20) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:737:2: rule__Person__Group_4_2__0
            	    {
            	    pushFollow(FOLLOW_rule__Person__Group_4_2__0_in_rule__Person__Group_4__2__Impl1447);
            	    rule__Person__Group_4_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

             after(grammarAccess.getPersonAccess().getGroup_4_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4__2__Impl"


    // $ANTLR start "rule__Person__Group_4_2__0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:753:1: rule__Person__Group_4_2__0 : rule__Person__Group_4_2__0__Impl rule__Person__Group_4_2__1 ;
    public final void rule__Person__Group_4_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:757:1: ( rule__Person__Group_4_2__0__Impl rule__Person__Group_4_2__1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:758:2: rule__Person__Group_4_2__0__Impl rule__Person__Group_4_2__1
            {
            pushFollow(FOLLOW_rule__Person__Group_4_2__0__Impl_in_rule__Person__Group_4_2__01484);
            rule__Person__Group_4_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Person__Group_4_2__1_in_rule__Person__Group_4_2__01487);
            rule__Person__Group_4_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4_2__0"


    // $ANTLR start "rule__Person__Group_4_2__0__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:765:1: rule__Person__Group_4_2__0__Impl : ( ',' ) ;
    public final void rule__Person__Group_4_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:769:1: ( ( ',' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:770:1: ( ',' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:770:1: ( ',' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:771:1: ','
            {
             before(grammarAccess.getPersonAccess().getCommaKeyword_4_2_0()); 
            match(input,20,FOLLOW_20_in_rule__Person__Group_4_2__0__Impl1515); 
             after(grammarAccess.getPersonAccess().getCommaKeyword_4_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4_2__0__Impl"


    // $ANTLR start "rule__Person__Group_4_2__1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:784:1: rule__Person__Group_4_2__1 : rule__Person__Group_4_2__1__Impl ;
    public final void rule__Person__Group_4_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:788:1: ( rule__Person__Group_4_2__1__Impl )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:789:2: rule__Person__Group_4_2__1__Impl
            {
            pushFollow(FOLLOW_rule__Person__Group_4_2__1__Impl_in_rule__Person__Group_4_2__11546);
            rule__Person__Group_4_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4_2__1"


    // $ANTLR start "rule__Person__Group_4_2__1__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:795:1: rule__Person__Group_4_2__1__Impl : ( ( rule__Person__MembershipsAssignment_4_2_1 ) ) ;
    public final void rule__Person__Group_4_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:799:1: ( ( ( rule__Person__MembershipsAssignment_4_2_1 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:800:1: ( ( rule__Person__MembershipsAssignment_4_2_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:800:1: ( ( rule__Person__MembershipsAssignment_4_2_1 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:801:1: ( rule__Person__MembershipsAssignment_4_2_1 )
            {
             before(grammarAccess.getPersonAccess().getMembershipsAssignment_4_2_1()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:802:1: ( rule__Person__MembershipsAssignment_4_2_1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:802:2: rule__Person__MembershipsAssignment_4_2_1
            {
            pushFollow(FOLLOW_rule__Person__MembershipsAssignment_4_2_1_in_rule__Person__Group_4_2__1__Impl1573);
            rule__Person__MembershipsAssignment_4_2_1();

            state._fsp--;


            }

             after(grammarAccess.getPersonAccess().getMembershipsAssignment_4_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__Group_4_2__1__Impl"


    // $ANTLR start "rule__Community__Group__0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:816:1: rule__Community__Group__0 : rule__Community__Group__0__Impl rule__Community__Group__1 ;
    public final void rule__Community__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:820:1: ( rule__Community__Group__0__Impl rule__Community__Group__1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:821:2: rule__Community__Group__0__Impl rule__Community__Group__1
            {
            pushFollow(FOLLOW_rule__Community__Group__0__Impl_in_rule__Community__Group__01607);
            rule__Community__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group__1_in_rule__Community__Group__01610);
            rule__Community__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__0"


    // $ANTLR start "rule__Community__Group__0__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:828:1: rule__Community__Group__0__Impl : ( 'community' ) ;
    public final void rule__Community__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:832:1: ( ( 'community' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:833:1: ( 'community' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:833:1: ( 'community' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:834:1: 'community'
            {
             before(grammarAccess.getCommunityAccess().getCommunityKeyword_0()); 
            match(input,21,FOLLOW_21_in_rule__Community__Group__0__Impl1638); 
             after(grammarAccess.getCommunityAccess().getCommunityKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__0__Impl"


    // $ANTLR start "rule__Community__Group__1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:847:1: rule__Community__Group__1 : rule__Community__Group__1__Impl rule__Community__Group__2 ;
    public final void rule__Community__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:851:1: ( rule__Community__Group__1__Impl rule__Community__Group__2 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:852:2: rule__Community__Group__1__Impl rule__Community__Group__2
            {
            pushFollow(FOLLOW_rule__Community__Group__1__Impl_in_rule__Community__Group__11669);
            rule__Community__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group__2_in_rule__Community__Group__11672);
            rule__Community__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__1"


    // $ANTLR start "rule__Community__Group__1__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:859:1: rule__Community__Group__1__Impl : ( ( rule__Community__NameAssignment_1 ) ) ;
    public final void rule__Community__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:863:1: ( ( ( rule__Community__NameAssignment_1 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:864:1: ( ( rule__Community__NameAssignment_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:864:1: ( ( rule__Community__NameAssignment_1 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:865:1: ( rule__Community__NameAssignment_1 )
            {
             before(grammarAccess.getCommunityAccess().getNameAssignment_1()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:866:1: ( rule__Community__NameAssignment_1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:866:2: rule__Community__NameAssignment_1
            {
            pushFollow(FOLLOW_rule__Community__NameAssignment_1_in_rule__Community__Group__1__Impl1699);
            rule__Community__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getCommunityAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__1__Impl"


    // $ANTLR start "rule__Community__Group__2"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:876:1: rule__Community__Group__2 : rule__Community__Group__2__Impl ;
    public final void rule__Community__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:880:1: ( rule__Community__Group__2__Impl )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:881:2: rule__Community__Group__2__Impl
            {
            pushFollow(FOLLOW_rule__Community__Group__2__Impl_in_rule__Community__Group__21729);
            rule__Community__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__2"


    // $ANTLR start "rule__Community__Group__2__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:887:1: rule__Community__Group__2__Impl : ( ( rule__Community__Group_2__0 )* ) ;
    public final void rule__Community__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:891:1: ( ( ( rule__Community__Group_2__0 )* ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:892:1: ( ( rule__Community__Group_2__0 )* )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:892:1: ( ( rule__Community__Group_2__0 )* )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:893:1: ( rule__Community__Group_2__0 )*
            {
             before(grammarAccess.getCommunityAccess().getGroup_2()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:894:1: ( rule__Community__Group_2__0 )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==16) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:894:2: rule__Community__Group_2__0
            	    {
            	    pushFollow(FOLLOW_rule__Community__Group_2__0_in_rule__Community__Group__2__Impl1756);
            	    rule__Community__Group_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);

             after(grammarAccess.getCommunityAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group__2__Impl"


    // $ANTLR start "rule__Community__Group_2__0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:910:1: rule__Community__Group_2__0 : rule__Community__Group_2__0__Impl rule__Community__Group_2__1 ;
    public final void rule__Community__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:914:1: ( rule__Community__Group_2__0__Impl rule__Community__Group_2__1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:915:2: rule__Community__Group_2__0__Impl rule__Community__Group_2__1
            {
            pushFollow(FOLLOW_rule__Community__Group_2__0__Impl_in_rule__Community__Group_2__01793);
            rule__Community__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2__1_in_rule__Community__Group_2__01796);
            rule__Community__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__0"


    // $ANTLR start "rule__Community__Group_2__0__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:922:1: rule__Community__Group_2__0__Impl : ( '{' ) ;
    public final void rule__Community__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:926:1: ( ( '{' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:927:1: ( '{' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:927:1: ( '{' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:928:1: '{'
            {
             before(grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0()); 
            match(input,16,FOLLOW_16_in_rule__Community__Group_2__0__Impl1824); 
             after(grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__0__Impl"


    // $ANTLR start "rule__Community__Group_2__1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:941:1: rule__Community__Group_2__1 : rule__Community__Group_2__1__Impl rule__Community__Group_2__2 ;
    public final void rule__Community__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:945:1: ( rule__Community__Group_2__1__Impl rule__Community__Group_2__2 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:946:2: rule__Community__Group_2__1__Impl rule__Community__Group_2__2
            {
            pushFollow(FOLLOW_rule__Community__Group_2__1__Impl_in_rule__Community__Group_2__11855);
            rule__Community__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Community__Group_2__2_in_rule__Community__Group_2__11858);
            rule__Community__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__1"


    // $ANTLR start "rule__Community__Group_2__1__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:953:1: rule__Community__Group_2__1__Impl : ( ( rule__Community__SubcommunitiesAssignment_2_1 )* ) ;
    public final void rule__Community__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:957:1: ( ( ( rule__Community__SubcommunitiesAssignment_2_1 )* ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:958:1: ( ( rule__Community__SubcommunitiesAssignment_2_1 )* )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:958:1: ( ( rule__Community__SubcommunitiesAssignment_2_1 )* )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:959:1: ( rule__Community__SubcommunitiesAssignment_2_1 )*
            {
             before(grammarAccess.getCommunityAccess().getSubcommunitiesAssignment_2_1()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:960:1: ( rule__Community__SubcommunitiesAssignment_2_1 )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( (LA9_0==21) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:960:2: rule__Community__SubcommunitiesAssignment_2_1
            	    {
            	    pushFollow(FOLLOW_rule__Community__SubcommunitiesAssignment_2_1_in_rule__Community__Group_2__1__Impl1885);
            	    rule__Community__SubcommunitiesAssignment_2_1();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);

             after(grammarAccess.getCommunityAccess().getSubcommunitiesAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__1__Impl"


    // $ANTLR start "rule__Community__Group_2__2"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:970:1: rule__Community__Group_2__2 : rule__Community__Group_2__2__Impl ;
    public final void rule__Community__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:974:1: ( rule__Community__Group_2__2__Impl )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:975:2: rule__Community__Group_2__2__Impl
            {
            pushFollow(FOLLOW_rule__Community__Group_2__2__Impl_in_rule__Community__Group_2__21916);
            rule__Community__Group_2__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__2"


    // $ANTLR start "rule__Community__Group_2__2__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:981:1: rule__Community__Group_2__2__Impl : ( '}' ) ;
    public final void rule__Community__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:985:1: ( ( '}' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:986:1: ( '}' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:986:1: ( '}' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:987:1: '}'
            {
             before(grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_2()); 
            match(input,17,FOLLOW_17_in_rule__Community__Group_2__2__Impl1944); 
             after(grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__Group_2__2__Impl"


    // $ANTLR start "rule__Acquaintance__Group__0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1006:1: rule__Acquaintance__Group__0 : rule__Acquaintance__Group__0__Impl rule__Acquaintance__Group__1 ;
    public final void rule__Acquaintance__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1010:1: ( rule__Acquaintance__Group__0__Impl rule__Acquaintance__Group__1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1011:2: rule__Acquaintance__Group__0__Impl rule__Acquaintance__Group__1
            {
            pushFollow(FOLLOW_rule__Acquaintance__Group__0__Impl_in_rule__Acquaintance__Group__01981);
            rule__Acquaintance__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Acquaintance__Group__1_in_rule__Acquaintance__Group__01984);
            rule__Acquaintance__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__0"


    // $ANTLR start "rule__Acquaintance__Group__0__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1018:1: rule__Acquaintance__Group__0__Impl : ( 'acquaintance' ) ;
    public final void rule__Acquaintance__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1022:1: ( ( 'acquaintance' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1023:1: ( 'acquaintance' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1023:1: ( 'acquaintance' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1024:1: 'acquaintance'
            {
             before(grammarAccess.getAcquaintanceAccess().getAcquaintanceKeyword_0()); 
            match(input,22,FOLLOW_22_in_rule__Acquaintance__Group__0__Impl2012); 
             after(grammarAccess.getAcquaintanceAccess().getAcquaintanceKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__0__Impl"


    // $ANTLR start "rule__Acquaintance__Group__1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1037:1: rule__Acquaintance__Group__1 : rule__Acquaintance__Group__1__Impl rule__Acquaintance__Group__2 ;
    public final void rule__Acquaintance__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1041:1: ( rule__Acquaintance__Group__1__Impl rule__Acquaintance__Group__2 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1042:2: rule__Acquaintance__Group__1__Impl rule__Acquaintance__Group__2
            {
            pushFollow(FOLLOW_rule__Acquaintance__Group__1__Impl_in_rule__Acquaintance__Group__12043);
            rule__Acquaintance__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Acquaintance__Group__2_in_rule__Acquaintance__Group__12046);
            rule__Acquaintance__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__1"


    // $ANTLR start "rule__Acquaintance__Group__1__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1049:1: rule__Acquaintance__Group__1__Impl : ( ( rule__Acquaintance__SourceAssignment_1 ) ) ;
    public final void rule__Acquaintance__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1053:1: ( ( ( rule__Acquaintance__SourceAssignment_1 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1054:1: ( ( rule__Acquaintance__SourceAssignment_1 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1054:1: ( ( rule__Acquaintance__SourceAssignment_1 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1055:1: ( rule__Acquaintance__SourceAssignment_1 )
            {
             before(grammarAccess.getAcquaintanceAccess().getSourceAssignment_1()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1056:1: ( rule__Acquaintance__SourceAssignment_1 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1056:2: rule__Acquaintance__SourceAssignment_1
            {
            pushFollow(FOLLOW_rule__Acquaintance__SourceAssignment_1_in_rule__Acquaintance__Group__1__Impl2073);
            rule__Acquaintance__SourceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintanceAccess().getSourceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__1__Impl"


    // $ANTLR start "rule__Acquaintance__Group__2"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1066:1: rule__Acquaintance__Group__2 : rule__Acquaintance__Group__2__Impl rule__Acquaintance__Group__3 ;
    public final void rule__Acquaintance__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1070:1: ( rule__Acquaintance__Group__2__Impl rule__Acquaintance__Group__3 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1071:2: rule__Acquaintance__Group__2__Impl rule__Acquaintance__Group__3
            {
            pushFollow(FOLLOW_rule__Acquaintance__Group__2__Impl_in_rule__Acquaintance__Group__22103);
            rule__Acquaintance__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Acquaintance__Group__3_in_rule__Acquaintance__Group__22106);
            rule__Acquaintance__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__2"


    // $ANTLR start "rule__Acquaintance__Group__2__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1078:1: rule__Acquaintance__Group__2__Impl : ( 'is' ) ;
    public final void rule__Acquaintance__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1082:1: ( ( 'is' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1083:1: ( 'is' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1083:1: ( 'is' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1084:1: 'is'
            {
             before(grammarAccess.getAcquaintanceAccess().getIsKeyword_2()); 
            match(input,23,FOLLOW_23_in_rule__Acquaintance__Group__2__Impl2134); 
             after(grammarAccess.getAcquaintanceAccess().getIsKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__2__Impl"


    // $ANTLR start "rule__Acquaintance__Group__3"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1097:1: rule__Acquaintance__Group__3 : rule__Acquaintance__Group__3__Impl rule__Acquaintance__Group__4 ;
    public final void rule__Acquaintance__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1101:1: ( rule__Acquaintance__Group__3__Impl rule__Acquaintance__Group__4 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1102:2: rule__Acquaintance__Group__3__Impl rule__Acquaintance__Group__4
            {
            pushFollow(FOLLOW_rule__Acquaintance__Group__3__Impl_in_rule__Acquaintance__Group__32165);
            rule__Acquaintance__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Acquaintance__Group__4_in_rule__Acquaintance__Group__32168);
            rule__Acquaintance__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__3"


    // $ANTLR start "rule__Acquaintance__Group__3__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1109:1: rule__Acquaintance__Group__3__Impl : ( ( rule__Acquaintance__TypeAssignment_3 ) ) ;
    public final void rule__Acquaintance__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1113:1: ( ( ( rule__Acquaintance__TypeAssignment_3 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1114:1: ( ( rule__Acquaintance__TypeAssignment_3 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1114:1: ( ( rule__Acquaintance__TypeAssignment_3 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1115:1: ( rule__Acquaintance__TypeAssignment_3 )
            {
             before(grammarAccess.getAcquaintanceAccess().getTypeAssignment_3()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1116:1: ( rule__Acquaintance__TypeAssignment_3 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1116:2: rule__Acquaintance__TypeAssignment_3
            {
            pushFollow(FOLLOW_rule__Acquaintance__TypeAssignment_3_in_rule__Acquaintance__Group__3__Impl2195);
            rule__Acquaintance__TypeAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintanceAccess().getTypeAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__3__Impl"


    // $ANTLR start "rule__Acquaintance__Group__4"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1126:1: rule__Acquaintance__Group__4 : rule__Acquaintance__Group__4__Impl rule__Acquaintance__Group__5 ;
    public final void rule__Acquaintance__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1130:1: ( rule__Acquaintance__Group__4__Impl rule__Acquaintance__Group__5 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1131:2: rule__Acquaintance__Group__4__Impl rule__Acquaintance__Group__5
            {
            pushFollow(FOLLOW_rule__Acquaintance__Group__4__Impl_in_rule__Acquaintance__Group__42225);
            rule__Acquaintance__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_rule__Acquaintance__Group__5_in_rule__Acquaintance__Group__42228);
            rule__Acquaintance__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__4"


    // $ANTLR start "rule__Acquaintance__Group__4__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1138:1: rule__Acquaintance__Group__4__Impl : ( 'of' ) ;
    public final void rule__Acquaintance__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1142:1: ( ( 'of' ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1143:1: ( 'of' )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1143:1: ( 'of' )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1144:1: 'of'
            {
             before(grammarAccess.getAcquaintanceAccess().getOfKeyword_4()); 
            match(input,24,FOLLOW_24_in_rule__Acquaintance__Group__4__Impl2256); 
             after(grammarAccess.getAcquaintanceAccess().getOfKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__4__Impl"


    // $ANTLR start "rule__Acquaintance__Group__5"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1157:1: rule__Acquaintance__Group__5 : rule__Acquaintance__Group__5__Impl ;
    public final void rule__Acquaintance__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1161:1: ( rule__Acquaintance__Group__5__Impl )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1162:2: rule__Acquaintance__Group__5__Impl
            {
            pushFollow(FOLLOW_rule__Acquaintance__Group__5__Impl_in_rule__Acquaintance__Group__52287);
            rule__Acquaintance__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__5"


    // $ANTLR start "rule__Acquaintance__Group__5__Impl"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1168:1: rule__Acquaintance__Group__5__Impl : ( ( rule__Acquaintance__TargetAssignment_5 ) ) ;
    public final void rule__Acquaintance__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1172:1: ( ( ( rule__Acquaintance__TargetAssignment_5 ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1173:1: ( ( rule__Acquaintance__TargetAssignment_5 ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1173:1: ( ( rule__Acquaintance__TargetAssignment_5 ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1174:1: ( rule__Acquaintance__TargetAssignment_5 )
            {
             before(grammarAccess.getAcquaintanceAccess().getTargetAssignment_5()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1175:1: ( rule__Acquaintance__TargetAssignment_5 )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1175:2: rule__Acquaintance__TargetAssignment_5
            {
            pushFollow(FOLLOW_rule__Acquaintance__TargetAssignment_5_in_rule__Acquaintance__Group__5__Impl2314);
            rule__Acquaintance__TargetAssignment_5();

            state._fsp--;


            }

             after(grammarAccess.getAcquaintanceAccess().getTargetAssignment_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__Group__5__Impl"


    // $ANTLR start "rule__SocialNetwork__EntitiesAssignment_2_0"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1198:1: rule__SocialNetwork__EntitiesAssignment_2_0 : ( ruleEntity ) ;
    public final void rule__SocialNetwork__EntitiesAssignment_2_0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1202:1: ( ( ruleEntity ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1203:1: ( ruleEntity )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1203:1: ( ruleEntity )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1204:1: ruleEntity
            {
             before(grammarAccess.getSocialNetworkAccess().getEntitiesEntityParserRuleCall_2_0_0()); 
            pushFollow(FOLLOW_ruleEntity_in_rule__SocialNetwork__EntitiesAssignment_2_02361);
            ruleEntity();

            state._fsp--;

             after(grammarAccess.getSocialNetworkAccess().getEntitiesEntityParserRuleCall_2_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__EntitiesAssignment_2_0"


    // $ANTLR start "rule__SocialNetwork__AcquaintancesAssignment_2_1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1213:1: rule__SocialNetwork__AcquaintancesAssignment_2_1 : ( ruleAcquaintance ) ;
    public final void rule__SocialNetwork__AcquaintancesAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1217:1: ( ( ruleAcquaintance ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1218:1: ( ruleAcquaintance )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1218:1: ( ruleAcquaintance )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1219:1: ruleAcquaintance
            {
             before(grammarAccess.getSocialNetworkAccess().getAcquaintancesAcquaintanceParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_ruleAcquaintance_in_rule__SocialNetwork__AcquaintancesAssignment_2_12392);
            ruleAcquaintance();

            state._fsp--;

             after(grammarAccess.getSocialNetworkAccess().getAcquaintancesAcquaintanceParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SocialNetwork__AcquaintancesAssignment_2_1"


    // $ANTLR start "rule__Person__NameAssignment_1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1228:1: rule__Person__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Person__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1232:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1233:1: ( RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1233:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1234:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__NameAssignment_12423); 
             after(grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__NameAssignment_1"


    // $ANTLR start "rule__Person__SexAssignment_3"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1243:1: rule__Person__SexAssignment_3 : ( ruleSex ) ;
    public final void rule__Person__SexAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1247:1: ( ( ruleSex ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1248:1: ( ruleSex )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1248:1: ( ruleSex )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1249:1: ruleSex
            {
             before(grammarAccess.getPersonAccess().getSexSexEnumRuleCall_3_0()); 
            pushFollow(FOLLOW_ruleSex_in_rule__Person__SexAssignment_32454);
            ruleSex();

            state._fsp--;

             after(grammarAccess.getPersonAccess().getSexSexEnumRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__SexAssignment_3"


    // $ANTLR start "rule__Person__MembershipsAssignment_4_1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1258:1: rule__Person__MembershipsAssignment_4_1 : ( ( RULE_ID ) ) ;
    public final void rule__Person__MembershipsAssignment_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1262:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1263:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1263:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1264:1: ( RULE_ID )
            {
             before(grammarAccess.getPersonAccess().getMembershipsCommunityCrossReference_4_1_0()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1265:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1266:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getMembershipsCommunityIDTerminalRuleCall_4_1_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__MembershipsAssignment_4_12489); 
             after(grammarAccess.getPersonAccess().getMembershipsCommunityIDTerminalRuleCall_4_1_0_1()); 

            }

             after(grammarAccess.getPersonAccess().getMembershipsCommunityCrossReference_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__MembershipsAssignment_4_1"


    // $ANTLR start "rule__Person__MembershipsAssignment_4_2_1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1277:1: rule__Person__MembershipsAssignment_4_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Person__MembershipsAssignment_4_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1281:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1282:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1282:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1283:1: ( RULE_ID )
            {
             before(grammarAccess.getPersonAccess().getMembershipsCommunityCrossReference_4_2_1_0()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1284:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1285:1: RULE_ID
            {
             before(grammarAccess.getPersonAccess().getMembershipsCommunityIDTerminalRuleCall_4_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Person__MembershipsAssignment_4_2_12528); 
             after(grammarAccess.getPersonAccess().getMembershipsCommunityIDTerminalRuleCall_4_2_1_0_1()); 

            }

             after(grammarAccess.getPersonAccess().getMembershipsCommunityCrossReference_4_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Person__MembershipsAssignment_4_2_1"


    // $ANTLR start "rule__Community__NameAssignment_1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1296:1: rule__Community__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Community__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1300:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1301:1: ( RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1301:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1302:1: RULE_ID
            {
             before(grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Community__NameAssignment_12563); 
             after(grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__NameAssignment_1"


    // $ANTLR start "rule__Community__SubcommunitiesAssignment_2_1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1311:1: rule__Community__SubcommunitiesAssignment_2_1 : ( ruleCommunity ) ;
    public final void rule__Community__SubcommunitiesAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1315:1: ( ( ruleCommunity ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1316:1: ( ruleCommunity )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1316:1: ( ruleCommunity )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1317:1: ruleCommunity
            {
             before(grammarAccess.getCommunityAccess().getSubcommunitiesCommunityParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_ruleCommunity_in_rule__Community__SubcommunitiesAssignment_2_12594);
            ruleCommunity();

            state._fsp--;

             after(grammarAccess.getCommunityAccess().getSubcommunitiesCommunityParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Community__SubcommunitiesAssignment_2_1"


    // $ANTLR start "rule__Acquaintance__SourceAssignment_1"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1326:1: rule__Acquaintance__SourceAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__Acquaintance__SourceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1330:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1331:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1331:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1332:1: ( RULE_ID )
            {
             before(grammarAccess.getAcquaintanceAccess().getSourcePersonCrossReference_1_0()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1333:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1334:1: RULE_ID
            {
             before(grammarAccess.getAcquaintanceAccess().getSourcePersonIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Acquaintance__SourceAssignment_12629); 
             after(grammarAccess.getAcquaintanceAccess().getSourcePersonIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getAcquaintanceAccess().getSourcePersonCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__SourceAssignment_1"


    // $ANTLR start "rule__Acquaintance__TypeAssignment_3"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1345:1: rule__Acquaintance__TypeAssignment_3 : ( ruleAcquaintanceType ) ;
    public final void rule__Acquaintance__TypeAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1349:1: ( ( ruleAcquaintanceType ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1350:1: ( ruleAcquaintanceType )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1350:1: ( ruleAcquaintanceType )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1351:1: ruleAcquaintanceType
            {
             before(grammarAccess.getAcquaintanceAccess().getTypeAcquaintanceTypeEnumRuleCall_3_0()); 
            pushFollow(FOLLOW_ruleAcquaintanceType_in_rule__Acquaintance__TypeAssignment_32664);
            ruleAcquaintanceType();

            state._fsp--;

             after(grammarAccess.getAcquaintanceAccess().getTypeAcquaintanceTypeEnumRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__TypeAssignment_3"


    // $ANTLR start "rule__Acquaintance__TargetAssignment_5"
    // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1360:1: rule__Acquaintance__TargetAssignment_5 : ( ( RULE_ID ) ) ;
    public final void rule__Acquaintance__TargetAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1364:1: ( ( ( RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1365:1: ( ( RULE_ID ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1365:1: ( ( RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1366:1: ( RULE_ID )
            {
             before(grammarAccess.getAcquaintanceAccess().getTargetPersonCrossReference_5_0()); 
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1367:1: ( RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl.ui/src-gen/hu/bme/mit/ui/contentassist/antlr/internal/InternalSocialNetworkLanguage.g:1368:1: RULE_ID
            {
             before(grammarAccess.getAcquaintanceAccess().getTargetPersonIDTerminalRuleCall_5_0_1()); 
            match(input,RULE_ID,FOLLOW_RULE_ID_in_rule__Acquaintance__TargetAssignment_52699); 
             after(grammarAccess.getAcquaintanceAccess().getTargetPersonIDTerminalRuleCall_5_0_1()); 

            }

             after(grammarAccess.getAcquaintanceAccess().getTargetPersonCrossReference_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Acquaintance__TargetAssignment_5"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork61 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialNetwork68 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__0_in_ruleSocialNetwork94 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleEntity_in_entryRuleEntity121 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleEntity128 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Entity__Alternatives_in_ruleEntity154 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_entryRulePerson181 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePerson188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__0_in_rulePerson214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_entryRuleCommunity241 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCommunity248 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__0_in_ruleCommunity274 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcquaintance_in_entryRuleAcquaintance301 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleAcquaintance308 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__0_in_ruleAcquaintance334 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Sex__Alternatives_in_ruleSex371 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__AcquaintanceType__Alternatives_in_ruleAcquaintanceType407 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__EntitiesAssignment_2_0_in_rule__SocialNetwork__Alternatives_2442 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__AcquaintancesAssignment_2_1_in_rule__SocialNetwork__Alternatives_2460 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_rule__Entity__Alternatives493 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_rule__Entity__Alternatives510 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_rule__Sex__Alternatives543 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_12_in_rule__Sex__Alternatives564 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_rule__AcquaintanceType__Alternatives600 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_rule__AcquaintanceType__Alternatives621 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__0__Impl_in_rule__SocialNetwork__Group__0654 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__1_in_rule__SocialNetwork__Group__0657 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_rule__SocialNetwork__Group__0__Impl685 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__1__Impl_in_rule__SocialNetwork__Group__1716 = new BitSet(new long[]{0x0000000000640000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__2_in_rule__SocialNetwork__Group__1719 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__SocialNetwork__Group__1__Impl747 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__2__Impl_in_rule__SocialNetwork__Group__2778 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__3_in_rule__SocialNetwork__Group__2781 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Alternatives_2_in_rule__SocialNetwork__Group__2__Impl810 = new BitSet(new long[]{0x0000000000640002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Alternatives_2_in_rule__SocialNetwork__Group__2__Impl822 = new BitSet(new long[]{0x0000000000640002L});
    public static final BitSet FOLLOW_rule__SocialNetwork__Group__3__Impl_in_rule__SocialNetwork__Group__3855 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__SocialNetwork__Group__3__Impl883 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__0__Impl_in_rule__Person__Group__0922 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group__1_in_rule__Person__Group__0925 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_rule__Person__Group__0__Impl953 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__1__Impl_in_rule__Person__Group__1984 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__Person__Group__2_in_rule__Person__Group__1987 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__NameAssignment_1_in_rule__Person__Group__1__Impl1014 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__2__Impl_in_rule__Person__Group__21044 = new BitSet(new long[]{0x0000000000001800L});
    public static final BitSet FOLLOW_rule__Person__Group__3_in_rule__Person__Group__21047 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__Person__Group__2__Impl1075 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__3__Impl_in_rule__Person__Group__31106 = new BitSet(new long[]{0x00000000000A0000L});
    public static final BitSet FOLLOW_rule__Person__Group__4_in_rule__Person__Group__31109 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__SexAssignment_3_in_rule__Person__Group__3__Impl1136 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__4__Impl_in_rule__Person__Group__41166 = new BitSet(new long[]{0x00000000000A0000L});
    public static final BitSet FOLLOW_rule__Person__Group__5_in_rule__Person__Group__41169 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__0_in_rule__Person__Group__4__Impl1196 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group__5__Impl_in_rule__Person__Group__51227 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__Person__Group__5__Impl1255 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__0__Impl_in_rule__Person__Group_4__01298 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group_4__1_in_rule__Person__Group_4__01301 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_rule__Person__Group_4__0__Impl1329 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__1__Impl_in_rule__Person__Group_4__11360 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_rule__Person__Group_4__2_in_rule__Person__Group_4__11363 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__MembershipsAssignment_4_1_in_rule__Person__Group_4__1__Impl1390 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4__2__Impl_in_rule__Person__Group_4__21420 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__0_in_rule__Person__Group_4__2__Impl1447 = new BitSet(new long[]{0x0000000000100002L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__0__Impl_in_rule__Person__Group_4_2__01484 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__1_in_rule__Person__Group_4_2__01487 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_20_in_rule__Person__Group_4_2__0__Impl1515 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__Group_4_2__1__Impl_in_rule__Person__Group_4_2__11546 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Person__MembershipsAssignment_4_2_1_in_rule__Person__Group_4_2__1__Impl1573 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__0__Impl_in_rule__Community__Group__01607 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Community__Group__1_in_rule__Community__Group__01610 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_rule__Community__Group__0__Impl1638 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__1__Impl_in_rule__Community__Group__11669 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_rule__Community__Group__2_in_rule__Community__Group__11672 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__NameAssignment_1_in_rule__Community__Group__1__Impl1699 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group__2__Impl_in_rule__Community__Group__21729 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__0_in_rule__Community__Group__2__Impl1756 = new BitSet(new long[]{0x0000000000010002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__0__Impl_in_rule__Community__Group_2__01793 = new BitSet(new long[]{0x0000000000260000L});
    public static final BitSet FOLLOW_rule__Community__Group_2__1_in_rule__Community__Group_2__01796 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_rule__Community__Group_2__0__Impl1824 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__1__Impl_in_rule__Community__Group_2__11855 = new BitSet(new long[]{0x0000000000260000L});
    public static final BitSet FOLLOW_rule__Community__Group_2__2_in_rule__Community__Group_2__11858 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Community__SubcommunitiesAssignment_2_1_in_rule__Community__Group_2__1__Impl1885 = new BitSet(new long[]{0x0000000000240002L});
    public static final BitSet FOLLOW_rule__Community__Group_2__2__Impl_in_rule__Community__Group_2__21916 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_rule__Community__Group_2__2__Impl1944 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__0__Impl_in_rule__Acquaintance__Group__01981 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__1_in_rule__Acquaintance__Group__01984 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_rule__Acquaintance__Group__0__Impl2012 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__1__Impl_in_rule__Acquaintance__Group__12043 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__2_in_rule__Acquaintance__Group__12046 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__SourceAssignment_1_in_rule__Acquaintance__Group__1__Impl2073 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__2__Impl_in_rule__Acquaintance__Group__22103 = new BitSet(new long[]{0x0000000000006000L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__3_in_rule__Acquaintance__Group__22106 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_23_in_rule__Acquaintance__Group__2__Impl2134 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__3__Impl_in_rule__Acquaintance__Group__32165 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__4_in_rule__Acquaintance__Group__32168 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__TypeAssignment_3_in_rule__Acquaintance__Group__3__Impl2195 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__4__Impl_in_rule__Acquaintance__Group__42225 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__5_in_rule__Acquaintance__Group__42228 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_24_in_rule__Acquaintance__Group__4__Impl2256 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__Group__5__Impl_in_rule__Acquaintance__Group__52287 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rule__Acquaintance__TargetAssignment_5_in_rule__Acquaintance__Group__5__Impl2314 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleEntity_in_rule__SocialNetwork__EntitiesAssignment_2_02361 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcquaintance_in_rule__SocialNetwork__AcquaintancesAssignment_2_12392 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__NameAssignment_12423 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleSex_in_rule__Person__SexAssignment_32454 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__MembershipsAssignment_4_12489 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Person__MembershipsAssignment_4_2_12528 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Community__NameAssignment_12563 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_rule__Community__SubcommunitiesAssignment_2_12594 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Acquaintance__SourceAssignment_12629 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleAcquaintanceType_in_rule__Acquaintance__TypeAssignment_32664 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rule__Acquaintance__TargetAssignment_52699 = new BitSet(new long[]{0x0000000000000002L});

}