package hu.bme.mit.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import hu.bme.mit.services.SocialNetworkLanguageGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalSocialNetworkLanguageParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'network'", "'{'", "'}'", "'person'", "'memberships'", "','", "'community'", "'acquaintance'", "'is'", "'of'", "'male'", "'female'", "'friend'", "'colleague'"
    };
    public static final int RULE_ID=4;
    public static final int T__24=24;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=6;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=5;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalSocialNetworkLanguageParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalSocialNetworkLanguageParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalSocialNetworkLanguageParser.tokenNames; }
    public String getGrammarFileName() { return "../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g"; }



     	private SocialNetworkLanguageGrammarAccess grammarAccess;
     	
        public InternalSocialNetworkLanguageParser(TokenStream input, SocialNetworkLanguageGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "SocialNetwork";	
       	}
       	
       	@Override
       	protected SocialNetworkLanguageGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleSocialNetwork"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:68:1: entryRuleSocialNetwork returns [EObject current=null] : iv_ruleSocialNetwork= ruleSocialNetwork EOF ;
    public final EObject entryRuleSocialNetwork() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSocialNetwork = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:69:2: (iv_ruleSocialNetwork= ruleSocialNetwork EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:70:2: iv_ruleSocialNetwork= ruleSocialNetwork EOF
            {
             newCompositeNode(grammarAccess.getSocialNetworkRule()); 
            pushFollow(FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75);
            iv_ruleSocialNetwork=ruleSocialNetwork();

            state._fsp--;

             current =iv_ruleSocialNetwork; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleSocialNetwork85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSocialNetwork"


    // $ANTLR start "ruleSocialNetwork"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:77:1: ruleSocialNetwork returns [EObject current=null] : (otherlv_0= 'network' otherlv_1= '{' ( ( (lv_entities_2_0= ruleEntity ) ) | ( (lv_acquaintances_3_0= ruleAcquaintance ) ) )+ otherlv_4= '}' ) ;
    public final EObject ruleSocialNetwork() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_4=null;
        EObject lv_entities_2_0 = null;

        EObject lv_acquaintances_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:80:28: ( (otherlv_0= 'network' otherlv_1= '{' ( ( (lv_entities_2_0= ruleEntity ) ) | ( (lv_acquaintances_3_0= ruleAcquaintance ) ) )+ otherlv_4= '}' ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:1: (otherlv_0= 'network' otherlv_1= '{' ( ( (lv_entities_2_0= ruleEntity ) ) | ( (lv_acquaintances_3_0= ruleAcquaintance ) ) )+ otherlv_4= '}' )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:1: (otherlv_0= 'network' otherlv_1= '{' ( ( (lv_entities_2_0= ruleEntity ) ) | ( (lv_acquaintances_3_0= ruleAcquaintance ) ) )+ otherlv_4= '}' )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:81:3: otherlv_0= 'network' otherlv_1= '{' ( ( (lv_entities_2_0= ruleEntity ) ) | ( (lv_acquaintances_3_0= ruleAcquaintance ) ) )+ otherlv_4= '}'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_11_in_ruleSocialNetwork122); 

                	newLeafNode(otherlv_0, grammarAccess.getSocialNetworkAccess().getNetworkKeyword_0());
                
            otherlv_1=(Token)match(input,12,FOLLOW_12_in_ruleSocialNetwork134); 

                	newLeafNode(otherlv_1, grammarAccess.getSocialNetworkAccess().getLeftCurlyBracketKeyword_1());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:89:1: ( ( (lv_entities_2_0= ruleEntity ) ) | ( (lv_acquaintances_3_0= ruleAcquaintance ) ) )+
            int cnt1=0;
            loop1:
            do {
                int alt1=3;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==14||LA1_0==17) ) {
                    alt1=1;
                }
                else if ( (LA1_0==18) ) {
                    alt1=2;
                }


                switch (alt1) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:89:2: ( (lv_entities_2_0= ruleEntity ) )
            	    {
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:89:2: ( (lv_entities_2_0= ruleEntity ) )
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:90:1: (lv_entities_2_0= ruleEntity )
            	    {
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:90:1: (lv_entities_2_0= ruleEntity )
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:91:3: lv_entities_2_0= ruleEntity
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSocialNetworkAccess().getEntitiesEntityParserRuleCall_2_0_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleEntity_in_ruleSocialNetwork156);
            	    lv_entities_2_0=ruleEntity();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSocialNetworkRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"entities",
            	            		lv_entities_2_0, 
            	            		"Entity");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;
            	case 2 :
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:108:6: ( (lv_acquaintances_3_0= ruleAcquaintance ) )
            	    {
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:108:6: ( (lv_acquaintances_3_0= ruleAcquaintance ) )
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:109:1: (lv_acquaintances_3_0= ruleAcquaintance )
            	    {
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:109:1: (lv_acquaintances_3_0= ruleAcquaintance )
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:110:3: lv_acquaintances_3_0= ruleAcquaintance
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getSocialNetworkAccess().getAcquaintancesAcquaintanceParserRuleCall_2_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleAcquaintance_in_ruleSocialNetwork183);
            	    lv_acquaintances_3_0=ruleAcquaintance();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getSocialNetworkRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"acquaintances",
            	            		lv_acquaintances_3_0, 
            	            		"Acquaintance");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);

            otherlv_4=(Token)match(input,13,FOLLOW_13_in_ruleSocialNetwork197); 

                	newLeafNode(otherlv_4, grammarAccess.getSocialNetworkAccess().getRightCurlyBracketKeyword_3());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSocialNetwork"


    // $ANTLR start "entryRuleEntity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:138:1: entryRuleEntity returns [EObject current=null] : iv_ruleEntity= ruleEntity EOF ;
    public final EObject entryRuleEntity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEntity = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:139:2: (iv_ruleEntity= ruleEntity EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:140:2: iv_ruleEntity= ruleEntity EOF
            {
             newCompositeNode(grammarAccess.getEntityRule()); 
            pushFollow(FOLLOW_ruleEntity_in_entryRuleEntity233);
            iv_ruleEntity=ruleEntity();

            state._fsp--;

             current =iv_ruleEntity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleEntity243); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEntity"


    // $ANTLR start "ruleEntity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:147:1: ruleEntity returns [EObject current=null] : (this_Person_0= rulePerson | this_Community_1= ruleCommunity ) ;
    public final EObject ruleEntity() throws RecognitionException {
        EObject current = null;

        EObject this_Person_0 = null;

        EObject this_Community_1 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:150:28: ( (this_Person_0= rulePerson | this_Community_1= ruleCommunity ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:151:1: (this_Person_0= rulePerson | this_Community_1= ruleCommunity )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:151:1: (this_Person_0= rulePerson | this_Community_1= ruleCommunity )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==14) ) {
                alt2=1;
            }
            else if ( (LA2_0==17) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:152:5: this_Person_0= rulePerson
                    {
                     
                            newCompositeNode(grammarAccess.getEntityAccess().getPersonParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_rulePerson_in_ruleEntity290);
                    this_Person_0=rulePerson();

                    state._fsp--;

                     
                            current = this_Person_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:162:5: this_Community_1= ruleCommunity
                    {
                     
                            newCompositeNode(grammarAccess.getEntityAccess().getCommunityParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_ruleCommunity_in_ruleEntity317);
                    this_Community_1=ruleCommunity();

                    state._fsp--;

                     
                            current = this_Community_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEntity"


    // $ANTLR start "entryRulePerson"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:178:1: entryRulePerson returns [EObject current=null] : iv_rulePerson= rulePerson EOF ;
    public final EObject entryRulePerson() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePerson = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:179:2: (iv_rulePerson= rulePerson EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:180:2: iv_rulePerson= rulePerson EOF
            {
             newCompositeNode(grammarAccess.getPersonRule()); 
            pushFollow(FOLLOW_rulePerson_in_entryRulePerson352);
            iv_rulePerson=rulePerson();

            state._fsp--;

             current =iv_rulePerson; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePerson362); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePerson"


    // $ANTLR start "rulePerson"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:187:1: rulePerson returns [EObject current=null] : (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ) ;
    public final EObject rulePerson() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Enumerator lv_sex_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:190:28: ( (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:191:1: (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:191:1: (otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}' )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:191:3: otherlv_0= 'person' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_sex_3_0= ruleSex ) ) (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )? otherlv_8= '}'
            {
            otherlv_0=(Token)match(input,14,FOLLOW_14_in_rulePerson399); 

                	newLeafNode(otherlv_0, grammarAccess.getPersonAccess().getPersonKeyword_0());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:195:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:196:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:196:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:197:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson416); 

            			newLeafNode(lv_name_1_0, grammarAccess.getPersonAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPersonRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_rulePerson433); 

                	newLeafNode(otherlv_2, grammarAccess.getPersonAccess().getLeftCurlyBracketKeyword_2());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:217:1: ( (lv_sex_3_0= ruleSex ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:218:1: (lv_sex_3_0= ruleSex )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:218:1: (lv_sex_3_0= ruleSex )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:219:3: lv_sex_3_0= ruleSex
            {
             
            	        newCompositeNode(grammarAccess.getPersonAccess().getSexSexEnumRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_ruleSex_in_rulePerson454);
            lv_sex_3_0=ruleSex();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getPersonRule());
            	        }
                   		set(
                   			current, 
                   			"sex",
                    		lv_sex_3_0, 
                    		"Sex");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:235:2: (otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )* )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==15) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:235:4: otherlv_4= 'memberships' ( (otherlv_5= RULE_ID ) ) (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    {
                    otherlv_4=(Token)match(input,15,FOLLOW_15_in_rulePerson467); 

                        	newLeafNode(otherlv_4, grammarAccess.getPersonAccess().getMembershipsKeyword_4_0());
                        
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:239:1: ( (otherlv_5= RULE_ID ) )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:240:1: (otherlv_5= RULE_ID )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:240:1: (otherlv_5= RULE_ID )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:241:3: otherlv_5= RULE_ID
                    {

                    			if (current==null) {
                    	            current = createModelElement(grammarAccess.getPersonRule());
                    	        }
                            
                    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson487); 

                    		newLeafNode(otherlv_5, grammarAccess.getPersonAccess().getMembershipsCommunityCrossReference_4_1_0()); 
                    	

                    }


                    }

                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:252:2: (otherlv_6= ',' ( (otherlv_7= RULE_ID ) ) )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==16) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:252:4: otherlv_6= ',' ( (otherlv_7= RULE_ID ) )
                    	    {
                    	    otherlv_6=(Token)match(input,16,FOLLOW_16_in_rulePerson500); 

                    	        	newLeafNode(otherlv_6, grammarAccess.getPersonAccess().getCommaKeyword_4_2_0());
                    	        
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:256:1: ( (otherlv_7= RULE_ID ) )
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:257:1: (otherlv_7= RULE_ID )
                    	    {
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:257:1: (otherlv_7= RULE_ID )
                    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:258:3: otherlv_7= RULE_ID
                    	    {

                    	    			if (current==null) {
                    	    	            current = createModelElement(grammarAccess.getPersonRule());
                    	    	        }
                    	            
                    	    otherlv_7=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePerson520); 

                    	    		newLeafNode(otherlv_7, grammarAccess.getPersonAccess().getMembershipsCommunityCrossReference_4_2_1_0()); 
                    	    	

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_8=(Token)match(input,13,FOLLOW_13_in_rulePerson536); 

                	newLeafNode(otherlv_8, grammarAccess.getPersonAccess().getRightCurlyBracketKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePerson"


    // $ANTLR start "entryRuleCommunity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:281:1: entryRuleCommunity returns [EObject current=null] : iv_ruleCommunity= ruleCommunity EOF ;
    public final EObject entryRuleCommunity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleCommunity = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:282:2: (iv_ruleCommunity= ruleCommunity EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:283:2: iv_ruleCommunity= ruleCommunity EOF
            {
             newCompositeNode(grammarAccess.getCommunityRule()); 
            pushFollow(FOLLOW_ruleCommunity_in_entryRuleCommunity572);
            iv_ruleCommunity=ruleCommunity();

            state._fsp--;

             current =iv_ruleCommunity; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleCommunity582); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleCommunity"


    // $ANTLR start "ruleCommunity"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:290:1: ruleCommunity returns [EObject current=null] : (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )* ) ;
    public final EObject ruleCommunity() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_subcommunities_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:293:28: ( (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )* ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:294:1: (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )* )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:294:1: (otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )* )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:294:3: otherlv_0= 'community' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )*
            {
            otherlv_0=(Token)match(input,17,FOLLOW_17_in_ruleCommunity619); 

                	newLeafNode(otherlv_0, grammarAccess.getCommunityAccess().getCommunityKeyword_0());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:298:1: ( (lv_name_1_0= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:299:1: (lv_name_1_0= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:299:1: (lv_name_1_0= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:300:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleCommunity636); 

            			newLeafNode(lv_name_1_0, grammarAccess.getCommunityAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getCommunityRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:316:2: (otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}' )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==12) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:316:4: otherlv_2= '{' ( (lv_subcommunities_3_0= ruleCommunity ) )* otherlv_4= '}'
            	    {
            	    otherlv_2=(Token)match(input,12,FOLLOW_12_in_ruleCommunity654); 

            	        	newLeafNode(otherlv_2, grammarAccess.getCommunityAccess().getLeftCurlyBracketKeyword_2_0());
            	        
            	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:320:1: ( (lv_subcommunities_3_0= ruleCommunity ) )*
            	    loop5:
            	    do {
            	        int alt5=2;
            	        int LA5_0 = input.LA(1);

            	        if ( (LA5_0==17) ) {
            	            alt5=1;
            	        }


            	        switch (alt5) {
            	    	case 1 :
            	    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:321:1: (lv_subcommunities_3_0= ruleCommunity )
            	    	    {
            	    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:321:1: (lv_subcommunities_3_0= ruleCommunity )
            	    	    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:322:3: lv_subcommunities_3_0= ruleCommunity
            	    	    {
            	    	     
            	    	    	        newCompositeNode(grammarAccess.getCommunityAccess().getSubcommunitiesCommunityParserRuleCall_2_1_0()); 
            	    	    	    
            	    	    pushFollow(FOLLOW_ruleCommunity_in_ruleCommunity675);
            	    	    lv_subcommunities_3_0=ruleCommunity();

            	    	    state._fsp--;


            	    	    	        if (current==null) {
            	    	    	            current = createModelElementForParent(grammarAccess.getCommunityRule());
            	    	    	        }
            	    	           		add(
            	    	           			current, 
            	    	           			"subcommunities",
            	    	            		lv_subcommunities_3_0, 
            	    	            		"Community");
            	    	    	        afterParserOrEnumRuleCall();
            	    	    	    

            	    	    }


            	    	    }
            	    	    break;

            	    	default :
            	    	    break loop5;
            	        }
            	    } while (true);

            	    otherlv_4=(Token)match(input,13,FOLLOW_13_in_ruleCommunity688); 

            	        	newLeafNode(otherlv_4, grammarAccess.getCommunityAccess().getRightCurlyBracketKeyword_2_2());
            	        

            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleCommunity"


    // $ANTLR start "entryRuleAcquaintance"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:350:1: entryRuleAcquaintance returns [EObject current=null] : iv_ruleAcquaintance= ruleAcquaintance EOF ;
    public final EObject entryRuleAcquaintance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAcquaintance = null;


        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:351:2: (iv_ruleAcquaintance= ruleAcquaintance EOF )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:352:2: iv_ruleAcquaintance= ruleAcquaintance EOF
            {
             newCompositeNode(grammarAccess.getAcquaintanceRule()); 
            pushFollow(FOLLOW_ruleAcquaintance_in_entryRuleAcquaintance726);
            iv_ruleAcquaintance=ruleAcquaintance();

            state._fsp--;

             current =iv_ruleAcquaintance; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleAcquaintance736); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAcquaintance"


    // $ANTLR start "ruleAcquaintance"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:359:1: ruleAcquaintance returns [EObject current=null] : (otherlv_0= 'acquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) otherlv_4= 'of' ( (otherlv_5= RULE_ID ) ) ) ;
    public final EObject ruleAcquaintance() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Enumerator lv_type_3_0 = null;


         enterRule(); 
            
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:362:28: ( (otherlv_0= 'acquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) otherlv_4= 'of' ( (otherlv_5= RULE_ID ) ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:363:1: (otherlv_0= 'acquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) otherlv_4= 'of' ( (otherlv_5= RULE_ID ) ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:363:1: (otherlv_0= 'acquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) otherlv_4= 'of' ( (otherlv_5= RULE_ID ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:363:3: otherlv_0= 'acquaintance' ( (otherlv_1= RULE_ID ) ) otherlv_2= 'is' ( (lv_type_3_0= ruleAcquaintanceType ) ) otherlv_4= 'of' ( (otherlv_5= RULE_ID ) )
            {
            otherlv_0=(Token)match(input,18,FOLLOW_18_in_ruleAcquaintance773); 

                	newLeafNode(otherlv_0, grammarAccess.getAcquaintanceAccess().getAcquaintanceKeyword_0());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:367:1: ( (otherlv_1= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:368:1: (otherlv_1= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:368:1: (otherlv_1= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:369:3: otherlv_1= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getAcquaintanceRule());
            	        }
                    
            otherlv_1=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleAcquaintance793); 

            		newLeafNode(otherlv_1, grammarAccess.getAcquaintanceAccess().getSourcePersonCrossReference_1_0()); 
            	

            }


            }

            otherlv_2=(Token)match(input,19,FOLLOW_19_in_ruleAcquaintance805); 

                	newLeafNode(otherlv_2, grammarAccess.getAcquaintanceAccess().getIsKeyword_2());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:384:1: ( (lv_type_3_0= ruleAcquaintanceType ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:385:1: (lv_type_3_0= ruleAcquaintanceType )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:385:1: (lv_type_3_0= ruleAcquaintanceType )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:386:3: lv_type_3_0= ruleAcquaintanceType
            {
             
            	        newCompositeNode(grammarAccess.getAcquaintanceAccess().getTypeAcquaintanceTypeEnumRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_ruleAcquaintanceType_in_ruleAcquaintance826);
            lv_type_3_0=ruleAcquaintanceType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getAcquaintanceRule());
            	        }
                   		set(
                   			current, 
                   			"type",
                    		lv_type_3_0, 
                    		"AcquaintanceType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_4=(Token)match(input,20,FOLLOW_20_in_ruleAcquaintance838); 

                	newLeafNode(otherlv_4, grammarAccess.getAcquaintanceAccess().getOfKeyword_4());
                
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:406:1: ( (otherlv_5= RULE_ID ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:407:1: (otherlv_5= RULE_ID )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:407:1: (otherlv_5= RULE_ID )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:408:3: otherlv_5= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getAcquaintanceRule());
            	        }
                    
            otherlv_5=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleAcquaintance858); 

            		newLeafNode(otherlv_5, grammarAccess.getAcquaintanceAccess().getTargetPersonCrossReference_5_0()); 
            	

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAcquaintance"


    // $ANTLR start "ruleSex"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:427:1: ruleSex returns [Enumerator current=null] : ( (enumLiteral_0= 'male' ) | (enumLiteral_1= 'female' ) ) ;
    public final Enumerator ruleSex() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:429:28: ( ( (enumLiteral_0= 'male' ) | (enumLiteral_1= 'female' ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:430:1: ( (enumLiteral_0= 'male' ) | (enumLiteral_1= 'female' ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:430:1: ( (enumLiteral_0= 'male' ) | (enumLiteral_1= 'female' ) )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==21) ) {
                alt7=1;
            }
            else if ( (LA7_0==22) ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:430:2: (enumLiteral_0= 'male' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:430:2: (enumLiteral_0= 'male' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:430:4: enumLiteral_0= 'male'
                    {
                    enumLiteral_0=(Token)match(input,21,FOLLOW_21_in_ruleSex908); 

                            current = grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getSexAccess().getMaleEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:436:6: (enumLiteral_1= 'female' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:436:6: (enumLiteral_1= 'female' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:436:8: enumLiteral_1= 'female'
                    {
                    enumLiteral_1=(Token)match(input,22,FOLLOW_22_in_ruleSex925); 

                            current = grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getSexAccess().getFemaleEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSex"


    // $ANTLR start "ruleAcquaintanceType"
    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:446:1: ruleAcquaintanceType returns [Enumerator current=null] : ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'colleague' ) ) ;
    public final Enumerator ruleAcquaintanceType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:448:28: ( ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'colleague' ) ) )
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:449:1: ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'colleague' ) )
            {
            // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:449:1: ( (enumLiteral_0= 'friend' ) | (enumLiteral_1= 'colleague' ) )
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==23) ) {
                alt8=1;
            }
            else if ( (LA8_0==24) ) {
                alt8=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }
            switch (alt8) {
                case 1 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:449:2: (enumLiteral_0= 'friend' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:449:2: (enumLiteral_0= 'friend' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:449:4: enumLiteral_0= 'friend'
                    {
                    enumLiteral_0=(Token)match(input,23,FOLLOW_23_in_ruleAcquaintanceType970); 

                            current = grammarAccess.getAcquaintanceTypeAccess().getFriendEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getAcquaintanceTypeAccess().getFriendEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:455:6: (enumLiteral_1= 'colleague' )
                    {
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:455:6: (enumLiteral_1= 'colleague' )
                    // ../hu.bme.mit.socialnetwork.dsl/src-gen/hu/bme/mit/parser/antlr/internal/InternalSocialNetworkLanguage.g:455:8: enumLiteral_1= 'colleague'
                    {
                    enumLiteral_1=(Token)match(input,24,FOLLOW_24_in_ruleAcquaintanceType987); 

                            current = grammarAccess.getAcquaintanceTypeAccess().getCollegueEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getAcquaintanceTypeAccess().getCollegueEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAcquaintanceType"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleSocialNetwork_in_entryRuleSocialNetwork75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleSocialNetwork85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleSocialNetwork122 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleSocialNetwork134 = new BitSet(new long[]{0x0000000000064000L});
    public static final BitSet FOLLOW_ruleEntity_in_ruleSocialNetwork156 = new BitSet(new long[]{0x0000000000066000L});
    public static final BitSet FOLLOW_ruleAcquaintance_in_ruleSocialNetwork183 = new BitSet(new long[]{0x0000000000066000L});
    public static final BitSet FOLLOW_13_in_ruleSocialNetwork197 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleEntity_in_entryRuleEntity233 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleEntity243 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_ruleEntity290 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleEntity317 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePerson_in_entryRulePerson352 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePerson362 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_rulePerson399 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson416 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_rulePerson433 = new BitSet(new long[]{0x0000000000600000L});
    public static final BitSet FOLLOW_ruleSex_in_rulePerson454 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_15_in_rulePerson467 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson487 = new BitSet(new long[]{0x0000000000012000L});
    public static final BitSet FOLLOW_16_in_rulePerson500 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePerson520 = new BitSet(new long[]{0x0000000000012000L});
    public static final BitSet FOLLOW_13_in_rulePerson536 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleCommunity_in_entryRuleCommunity572 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleCommunity582 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_ruleCommunity619 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleCommunity636 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_12_in_ruleCommunity654 = new BitSet(new long[]{0x0000000000026000L});
    public static final BitSet FOLLOW_ruleCommunity_in_ruleCommunity675 = new BitSet(new long[]{0x0000000000026000L});
    public static final BitSet FOLLOW_13_in_ruleCommunity688 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_ruleAcquaintance_in_entryRuleAcquaintance726 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleAcquaintance736 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_ruleAcquaintance773 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleAcquaintance793 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_ruleAcquaintance805 = new BitSet(new long[]{0x0000000001800000L});
    public static final BitSet FOLLOW_ruleAcquaintanceType_in_ruleAcquaintance826 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_ruleAcquaintance838 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleAcquaintance858 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_21_in_ruleSex908 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_ruleSex925 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_23_in_ruleAcquaintanceType970 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_24_in_ruleAcquaintanceType987 = new BitSet(new long[]{0x0000000000000002L});

}